<script setup lang="ts">
    import { TableauDeMesures } from '@/interventionServiceOffer/entities/tableauDeMesures/TableauDeMesures'
    import { TableauDeMesuresApi } from '@/interventionServiceOffer/entities/tableauDeMesures/TableauDeMesuresApi'
    import { useMsal } from '@/plugins/msal/useMsal'
    import { serviceOfferIdInjectionKey } from '@/shared/constants'
    import {
        moduloPositif,
        nombreAvecSigneString,
    } from '@/shared/helpers/numbers'
    import { isUndefined, requiredInject } from '@/shared/helpers/types'
    import { computed, onBeforeUnmount, ref, Ref, watch } from 'vue'
    import SContextualNavbar from '@/shared/navbar/components/SContextualNavbar.vue'
    import SContentContainerFullView from '@/shared/components/SContentContainerFullView.vue'
    import { VSkeletonLoader } from 'vuetify/lib/components/index.mjs'
    import { RequestAborter } from '@/shared/api/entities/RequestAborter'
    import { SilabError } from '@/shared/errors/SilabError'
    import { LoadingManager } from '@/shared/helpers/lifeCycle'
    import { ConfigurationTableauDeMesuresApi } from '@/interventionServiceOffer/entities/configurationTableauDeMesures/ConfigurationTableauDeMesuresApi'
    import { ConfigurationTableauDeMesures } from '@/interventionServiceOffer/entities/configurationTableauDeMesures/ConfigurationTableauDeMesures'
    import {
        stringToOptionalNumberQueryTransformOption,
        useQueryParamBindingWithtransform,
    } from '@/shared/routing/composables/useQueryParamBinding'
    import { z } from 'zod'

    const serviceOfferId = requiredInject(serviceOfferIdInjectionKey)
    const msal = useMsal()
    const configurationTableauDeMesuresApi =
        new ConfigurationTableauDeMesuresApi(msal)
    const tableauDeMesuresApi = new TableauDeMesuresApi(msal)
    const configurationTableauDeMesuresApiFetchAborter: RequestAborter =
        new RequestAborter()
    const tableauDeMesuresApiFetchAborter: RequestAborter = new RequestAborter()

    const loadingManager: LoadingManager = new LoadingManager()
    const nombreDeColonnes = 7
    const intervallesDeTempsEntreLesColonnesEnSecondes = 24 * 60 * 60

    const idConfigurationTableauDeMesureSelectionné = ref<number | undefined>()
    useQueryParamBindingWithtransform(
        'idConfigurationTableauDeMesureSelectionné',
        idConfigurationTableauDeMesureSelectionné,
        z.string().optional(),
        stringToOptionalNumberQueryTransformOption
    )
    const tableauDeMesure: Ref<TableauDeMesures | undefined> = ref()
    const panneauDeSelectionDeTableauOuvert = ref(false)
    const configurationsTableauDeMesure: Ref<
        Array<ConfigurationTableauDeMesures>
    > = ref([])

    const donnéesDataTableVuetify = computed(() => {
        if (isUndefined(tableauDeMesure.value)) {
            return undefined
        }
        return convertirTableauDeMesureVersDonnéesDataTableVuetify(
            tableauDeMesure.value
        )
    })

    //Note: ne fonctionne que pour les semaines
    const dateDeDébutDeLaPériode = computed(() => {
        const dateCourrante = new Date()
        // on veut 0 = lundi et non pas dimanche merci les américains https://developer.mozilla.org/fr/docs/Web/JavaScript/Reference/Global_Objects/Date/getDay
        const jourDeLaSemaineCourranteFrancaise = moduloPositif(
            dateCourrante.getDay() - 1,
            nombreDeColonnes
        )
        const jourDuMoisDuPremierDeLaSemaineCourrante =
            dateCourrante.getDate() - jourDeLaSemaineCourranteFrancaise

        const dateDupremierJourDeLaSemaine = new Date()
        dateDupremierJourDeLaSemaine.setDate(
            jourDuMoisDuPremierDeLaSemaineCourrante +
                deltaPériode.value * nombreDeColonnes
        )
        dateDupremierJourDeLaSemaine.setHours(0)
        dateDupremierJourDeLaSemaine.setMinutes(0)
        dateDupremierJourDeLaSemaine.setSeconds(0)
        dateDupremierJourDeLaSemaine.setMilliseconds(0)
        return dateDupremierJourDeLaSemaine
    })

    function contruireNomColonneDuVDataTable(
        indexIntervalle: number,
        indexSousCellule: number
    ) {
        return `col${indexIntervalle}-cel${indexSousCellule}`
    }

    function convertirTableauDeMesureVersDonnéesDataTableVuetify(
        tableauDeMesures: TableauDeMesures
    ) {
        return {
            headers: [
                {
                    title: tableauDeMesures.titre,
                    value: 'titre',
                },
                ...tableauDeMesures.dates.map((date, indexIntervalle) => {
                    return {
                        title: date.toLocaleDateString(undefined, {
                            weekday: 'long',
                            day: 'numeric',
                        }),
                        align: 'center' as const,
                        children: tableauDeMesures.sousCellules.map(
                            (titreDeLaSousCellule, indexSousCellule) => ({
                                title: titreDeLaSousCellule,
                                align: 'center' as const,
                                value: contruireNomColonneDuVDataTable(
                                    indexIntervalle,
                                    indexSousCellule
                                ),
                            })
                        ),
                    }
                }),
            ],
            items: tableauDeMesures.lignes.map((ligne) =>
                Object.assign(
                    { titre: ligne.titre },
                    ...ligne.mesures.flatMap((mesure, indexIntervalle) =>
                        mesure.map((valeur, indexSousCellule) => ({
                            [contruireNomColonneDuVDataTable(
                                indexIntervalle,
                                indexSousCellule
                            )]: isUndefined(valeur) ? '-' : valeur,
                        }))
                    )
                )
            ),
        }
    }
    /**
     * 0 = cette semaine
     */

    const deltaPériode: Ref<number> = ref(0)
    watch(
        [msal.accounts, serviceOfferId],
        () => {
            configurationsTableauDeMesure.value = []
            idConfigurationTableauDeMesureSelectionné.value = undefined

            configurationTableauDeMesuresApiFetchAborter.abortRequestsAndRefreshAborter()
            const stopLoading = loadingManager.startLoading()

            configurationTableauDeMesuresApi
                .getAll(
                    serviceOfferId.value,
                    configurationTableauDeMesuresApiFetchAborter.getSignal()
                )
                .then((fetchedConfigurationTableauDeMesures) => {
                    configurationsTableauDeMesure.value =
                        fetchedConfigurationTableauDeMesures

                    if (fetchedConfigurationTableauDeMesures.length > 0) {
                        idConfigurationTableauDeMesureSelectionné.value =
                            fetchedConfigurationTableauDeMesures[0].id
                    }
                })
                .catch((error) => {
                    // dans le cas d'une annulation, on ne fait rien
                    if (error.name !== 'AbortError') {
                        throw new SilabError(
                            `Erreur lors de la récupération des compteurs`,
                            error
                        )
                    }
                })
                .finally(() => {
                    stopLoading()
                })
        },
        {
            immediate: true,
        }
    )

    watch(
        [
            msal.accounts,
            serviceOfferId,
            dateDeDébutDeLaPériode,
            idConfigurationTableauDeMesureSelectionné,
        ],
        () => {
            tableauDeMesure.value = undefined

            if (isUndefined(idConfigurationTableauDeMesureSelectionné.value)) {
                return
            }

            tableauDeMesuresApiFetchAborter.abortRequestsAndRefreshAborter()
            const stopLoading = loadingManager.startLoading()

            tableauDeMesuresApi
                .getPeriode(
                    serviceOfferId.value,
                    idConfigurationTableauDeMesureSelectionné.value,
                    dateDeDébutDeLaPériode.value,
                    nombreDeColonnes,
                    intervallesDeTempsEntreLesColonnesEnSecondes,
                    tableauDeMesuresApiFetchAborter.getSignal()
                )
                .then((fetchedTableauDeMesure) => {
                    tableauDeMesure.value = fetchedTableauDeMesure
                })
                .catch((error) => {
                    // dans le cas d'une annulation, on ne fait rien
                    if (error.name !== 'AbortError') {
                        throw new SilabError(
                            `Erreur lors de la récupération des compteurs`,
                            error
                        )
                    }
                })
                .finally(() => {
                    stopLoading()
                })
        },
        {
            immediate: true,
        }
    )

    onBeforeUnmount(() => {
        configurationTableauDeMesuresApiFetchAborter.abortRequests()
        tableauDeMesuresApiFetchAborter.abortRequests()
    })
</script>
<template>
    <s-contextual-navbar page-title="Tableaux de relèves">
        <template #contextualButtons>
            <v-btn
                :disabled="configurationsTableauDeMesure.length < 1"
                icon="mdi-menu"
                color="on-background"
                @click="
                    panneauDeSelectionDeTableauOuvert =
                        !panneauDeSelectionDeTableauOuvert
                "
            ></v-btn>
        </template>
    </s-contextual-navbar>
    <v-main>
        <s-content-container-full-view class="d-flex">
            <v-navigation-drawer v-model="panneauDeSelectionDeTableauOuvert">
                <v-list>
                    <v-list-item
                        v-for="configurationTableauDeMesures in configurationsTableauDeMesure"
                        :key="configurationTableauDeMesures.id"
                        style="cursor: pointer"
                        @click="
                            () => {
                                panneauDeSelectionDeTableauOuvert = false
                                idConfigurationTableauDeMesureSelectionné =
                                    configurationTableauDeMesures.id
                            }
                        "
                        prepend-icon="mdi-table"
                    >
                        {{ configurationTableauDeMesures.titre }}
                    </v-list-item>
                </v-list>
            </v-navigation-drawer>
            <v-data-table
                :headers="donnéesDataTableVuetify?.headers"
                :items="donnéesDataTableVuetify?.items"
                :items-per-page="donnéesDataTableVuetify?.items.length"
                style="height: 100%"
                :loading="loadingManager.isLoading.value"
                fixed-footer
                fixed-header
                no-data-text="Il n'y a pas de tableau de relèves configuré"
            >
                <template #bottom>
                    <div
                        style="
                            border-top: 1px solid lightgrey;
                            display: flex;
                            align-items: center;
                            justify-content: space-between;
                            flex-wrap: wrap;
                        "
                        class="px-3"
                    >
                        <div></div>
                        <div>
                            <v-btn
                                variant="text"
                                icon="mdi-chevron-double-left"
                                @click="deltaPériode--"
                            ></v-btn>
                            semaine
                            {{
                                deltaPériode === 0
                                    ? 'actuelle'
                                    : nombreAvecSigneString(deltaPériode)
                            }}
                            <v-btn
                                variant="text"
                                icon="mdi-chevron-double-right"
                                @click="deltaPériode++"
                            ></v-btn>
                        </div>
                        <div>
                            {{
                                tableauDeMesure?.dates[0]?.toLocaleDateString(
                                    undefined,
                                    { month: 'long', year: 'numeric' }
                                )
                            }}
                        </div>
                    </div>
                </template>
                <!-- normalement le v-if n'est pas censé être nécessaire (cf. https://vuetifyjs.com/en/api/v-data-table/#slots-loading) mais en fait si... -->
                <template v-if="isUndefined(donnéesDataTableVuetify)" #loading>
                    <v-skeleton-loader type="table-heading, table-tbody" />
                </template>
            </v-data-table>
        </s-content-container-full-view>
    </v-main>
</template>

<style>
    .v-table tr:nth-of-type(odd) {
        background: rgb(0, 0, 0, 0.035);
    }
</style>
